> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Threaded Messages

> Threaded Messages — CometChat documentation.

## Overview

ThreadedMessages is a [Composite Component](/ui-kit/react/v4/components-overview#composite-components) that displays all replies made to a particular message in a conversation. By default, the parent message will be displayed at the top, the message composer will be at the bottom and between them a message list will contain all replies.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/60KLvpM3Vx0byZeU/images/baa214c1-threaded_messages_overview_web_screens-d7ce5e9d85efcafade9cbf2c60e098e7.png?fit=max&auto=format&n=60KLvpM3Vx0byZeU&q=85&s=580bc9214096db46ffacc4353b107871" width="3600" height="2400" data-path="images/baa214c1-threaded_messages_overview_web_screens-d7ce5e9d85efcafade9cbf2c60e098e7.png" />
</Frame>

ThreadedMessages is composed of the following components:

| Component                                            | Description                                                                                                        |
| ---------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------ |
| [MessageList](/ui-kit/react/v4/message-list)         | CometChatMessageList is a component that displays a list of Messages                                               |
| [MessageComposer](/ui-kit/react/v4/message-composer) | CometChatMessageComposer is a component that helps in writing and editing of messages and also sending attachments |

## Usage

### Integration

The following code snippet illustrates how you can directly incorporate the ThreadedMessages component into your Application.

<Tabs>
  <Tab title="ThreadedMessagesDemo.tsx">
    ```typescript theme={null}
    import React from "react";
    import { CometChatThreadedMessages, ThreadedMessagesStyle } from "@cometchat/chat-uikit-react";
    import {CometChat} from "@cometchat/chat-sdk-javascript";

    const bubbleView = () => {
      return <div>your custom bubble view</div>;
    };

    export function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
    }, []);

      const threadedMessagesStyle = new ThreadedMessagesStyle({
        titleColor: "#6615e8",
        background: "#ebdeff",
        width: "100%",
        height: "600px",
        border: "2px solid #9e19e0"
      });

      const getTitle = () => {
        return `Thread ${chatWithUser?.getName()}`;
      };

      return chatWithUser && parentMessage ? (
        <CometChatThreadedMessages
          parentMessage={parentMessage}
          bubbleView={bubbleView}
          title={getTitle()}
          threadedMessagesStyle={threadedMessagesStyle}
        />
      ) : null;
    }
    ```
  </Tab>

  <Tab title="App.tsx">
    ```typescript theme={null}
    import { ThreadedMessagesDemo } from "./ThreadedMessagesDemo";

    export default function App() {
      return (
        <div className="App">
          <div>
            <ThreadedMessagesDemo />
          </div>
        </div>
      );
    }
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/ui-kit/react/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

**Example**

In this example, we are overriding the `onClose` of the ThreadedMesssage Component.

<Tabs>
  <Tab title="ThreadedMessagesDemo.tsx">
    ```typescript theme={null}
    import React from "react";
    import { CometChatThreadedMessages, ThreadedMessagesStyle , MessageListConfiguration } from "@cometchat/chat-uikit-react";
    import {CometChat} from "@cometchat/chat-sdk-javascript";

    const bubbleView = () => {
      return <div>your custom bubble view</div>;
    };

    export function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
    }, []);

      const getonClose = () => {
        console.log("your custom on close action");
       }

      return chatWithUser && parentMessage ? (
        <CometChatThreadedMessages
          parentMessage={parentMessage}
          bubbleView={bubbleView}
          onClose:getonClose
        />
      ) : null;
    }
    ```
  </Tab>
</Tabs>

***

### Filters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

ThreadedMessages does not have its own Filters. However, you can filter the messages list in ThreadedMessages Component using [MessageListConfiguration](#messagelist).

**Example**

In this example, we are filtering messages based on the ParentMessageID and searching for messages that contain the keyword "hi".

<Tabs>
  <Tab title="ThreadedMessagesDemo.tsx">
    ```typescript theme={null}
    import React from "react";
    import { CometChatThreadedMessages, ThreadedMessagesStyle , MessageListConfiguration } from "@cometchat/chat-uikit-react";
    import {CometChat} from "@cometchat/chat-sdk-javascript";

    const bubbleView = () => {
      return <div>your custom bubble view</div>;
    };

    export function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
    }, []);

      return chatWithUser && parentMessage ? (
        <CometChatThreadedMessages
          parentMessage={parentMessage}
          bubbleView={bubbleView}
          messageListConfiguration={new MessageListConfiguration({
            messagesRequestBuilder: new CometChat.MessagesRequestBuilder().setParentMessageId(546).setSearchKeyword("hi").setLimit(1)
          })}
        />
      ) : null;
    }
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/ui-kit/react/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

The ThreadedMessages Component does not emit any events of its own.

***

## Customization

To fit your app's design requirements, you can customize the appearance of the conversation component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

***

### Style

Using Style you can customize the look and feel of the component in your app, These parameters typically control elements such as the color, size, shape, and fonts used within the component.

#### 1. threadedMessagesStyle

To modify the styling, you can apply the ThreadedMessageStyle to the ThreadedMessage Component using the `threadedMessagesStyle` property.

<Tabs>
  <Tab title="ThreadedMessagesDemo.tsx">
    ```typescript theme={null}
    import React from "react";
    import { CometChatThreadedMessages, ThreadedMessagesStyle } from "@cometchat/chat-uikit-react";
    import {CometChat} from "@cometchat/chat-sdk-javascript";

    const bubbleView = () => {
      return <div>your custom bubble view</div>;
    };

    export function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
    }, []);
      const threadedMessagesStyle = new ThreadedMessagesStyle({
        background: "#ebdeff",
        width: "100%",
        height: "600px",
        border: "2px solid #9e19e0"
      });

      return chatWithUser && parentMessage ? (
        <CometChatThreadedMessages
          parentMessage={parentMessage}
          bubbleView={bubbleView}
          threadedMessagesStyle={threadedMessagesStyle}
        />
      ) : null;
    }
    ```
  </Tab>
</Tabs>

The following properties are exposed by `ThreadedMessagesStyle`:

| Methods           | Description                                             | Type                      |
| ----------------- | ------------------------------------------------------- | ------------------------- |
| **border**        | Used to set border                                      | `border?: string,`        |
| **borderRadius**  | Used to set border radius                               | `borderRadius?: string;`  |
| **background**    | Used to set background colour                           | `background?: string;`    |
| **height**        | Used to set height                                      | `height?: string;`        |
| **width**         | Used to set width                                       | `width?: string;`         |
| **titleFont**     | used to customise the font of the title in the app bar  | `titleFont?: string;`     |
| **titleColor**    | used to customise the color of the title in the app bar | `titleColor?: string;`    |
| **closeIconTint** | used to set the color of the close icon in the app bar  | `closeIconTint?: string;` |

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

<Tabs>
  <Tab title="ThreadedMessagesDemo.tsx">
    ```typescript theme={null}
    import React from "react";
    import { CometChatThreadedMessages } from "@cometchat/chat-uikit-react";
    import {CometChat} from "@cometchat/chat-sdk-javascript";

    const bubbleView = () => {
      return <div>your custom bubble view</div>;
    };

    export function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
      }, []);
      const getTitle = () => {
        return `Thread of ${chatWithUser?.getName()}`;
      };

      return chatWithUser && parentMessage ? (
        <CometChatThreadedMessages
          parentMessage={parentMessage}
          bubbleView={bubbleView}
          title={getTitle()}
          closeIconURL="your custom close icon url"
        />
      ) : null;
    }
    ```
  </Tab>
</Tabs>

Below is a list of customizations along with corresponding code snippets

| Property                     | Description                                                           | Code                                        |
| ---------------------------- | --------------------------------------------------------------------- | ------------------------------------------- |
| **parentMessage** [report]() | Used to to set the message for which the replies need to be fetched   | `parentMessage={parentMessage}`             |
| **Hide MessageComposer**     | Used to toggle visibility for CometChatMessageComposer, default false | `hideMessageComposer={true}`                |
| **title**                    | Used to set title in the app bar                                      | `title={getTitle()}`                        |
| **closeIconURL**             | Used to set the icon to exit the widget                               | `closeIconURL="your custom close icon url"` |

***

### Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

#### BubbleView

By using `bubbleView`, You can set parent message bubble view inside ThreadedMessage Component.

**Example**

**Default**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/aledzZZMtw_sXx4U/images/f9fbbc9c-threaded_messages_bubbleview_default_web_screens-b84cc7fe214fa4e70518ff431d89008c.png?fit=max&auto=format&n=aledzZZMtw_sXx4U&q=85&s=133aeaff2ce2e663a58d778aa89a9ab4" width="3600" height="2400" data-path="images/f9fbbc9c-threaded_messages_bubbleview_default_web_screens-b84cc7fe214fa4e70518ff431d89008c.png" />
</Frame>

**Custom**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/v4EbHQCGZ54oJcmr/images/57cae1e6-threaded_messages_bubbleview_custom_web_screens-8ae16601fe81efe66ef9890a5542c2a2.png?fit=max&auto=format&n=v4EbHQCGZ54oJcmr&q=85&s=b00921dbf1dfa1f2966644f345967538" width="3600" height="2400" data-path="images/57cae1e6-threaded_messages_bubbleview_custom_web_screens-8ae16601fe81efe66ef9890a5542c2a2.png" />
</Frame>

In this example, we will set parent message bubble view using `bubbleView` and apply custom styles on it.

<Tabs>
  <Tab title="ThreadedMessagesDemo.tsx">
    ```typescript theme={null}
    import React from "react";
    import { CometChatThreadedMessages, ListItemStyle } from "@cometchat/chat-uikit-react";
    import {CometChat} from "@cometchat/chat-sdk-javascript";

    const bubbleView = () => {
        const listItemStyle = new ListItemStyle({
            width: "150px",
            height: "100%",
            border: "2px solid #6615e8",
            borderRadius:"12px",
            titleColor:"#ffffff",
            background:"rgb(104, 81, 214)"
          });
        return(
            <cometchat-list-item title ={(parentMessage as CometChat.TextMessage).getText()} listItemStyle={JSON.stringify(listItemStyle)} />
        )
      };

    export function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
      }, []);

      return chatWithUser && parentMessage ? (
        <CometChatThreadedMessages
          parentMessage={parentMessage}
          bubbleView={bubbleView}
        />
      ) : null;
    }
    ```
  </Tab>
</Tabs>

#### MessageActionView

By utilizing the `messageActionView` method, you can assign custom actions to the parent message bubble view inside the ThreadedMessage Component.

**Example**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/8YlylzCf9CehSaWO/images/cbe3d276-threaded_messages_actionview_web_screens-af8001a225e368848ca95bf650161733.png?fit=max&auto=format&n=8YlylzCf9CehSaWO&q=85&s=7b0f520131e5c909352eda93b02d252f" width="3600" height="2400" data-path="images/cbe3d276-threaded_messages_actionview_web_screens-af8001a225e368848ca95bf650161733.png" />
</Frame>

In this example, we are setting mock Chat Bot button as message action view in ThreadedMessages Component.

<Tabs>
  <Tab title="ThreadedMessagesDemo.tsx">
    ```typescript theme={null}
    import React from "react";
    import { CometChatThreadedMessages, ListItemStyle } from "@cometchat/chat-uikit-react";
    import {CometChat} from "@cometchat/chat-sdk-javascript";

     const messageActionView = () =>{
        return (
            <div style={{ height: '30px', width: '70px', background: '#a46efa', borderRadius: '20px', display: 'flex', justifyContent: 'center', alignItems: 'center'}}>
                <button style={{ height: '20px', width: '50px', background: '#a46efa', border: 'none', display: 'flex', justifyContent: 'center', alignItems: 'center', cursor:"pointer",color:'#ffffff'  }}>
                    chatbot
                    <img src="custom image" style={{ height: 'auto', width: '100%', maxWidth: '100%', maxHeight: '100%', borderRadius: '50%'}} alt="bot" />
                </button>
            </div>
        )
      }

      const bubbleView = () => {
        const listItemStyle = new ListItemStyle({
            width: "150px",
            height: "100%",
            border: "2px solid #6615e8",
            borderRadius:"12px",
            titleColor:"#ffffff",
            background:"rgb(104, 81, 214)"
          });
        return(
            <cometchat-list-item title ={(parentMessage as CometChat.TextMessage).getText()} listItemStyle={JSON.stringify(listItemStyle)} />
        )
      };

    export function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
      }, []);

      return chatWithUser && parentMessage ? (
        <CometChatThreadedMessages
          parentMessage={parentMessage}
          bubbleView={bubbleView}
          messageActionView={messageActionView()}
        />
      ) : null;
    }
    ```
  </Tab>
</Tabs>

***

#### MessageListView

You can set your custom message list view using the `messageListView` property. But keep in mind, by using this you will override the default message ListView functionality.

```javascript theme={null}
messageListView = { CustomListItem };
```

**Example**

**Default**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/RxKy5RgybeX-8GbH/images/19a21493-message_list_view_default_web_screens-114b0cdcdf4968978684b0c200cf18ab.png?fit=max&auto=format&n=RxKy5RgybeX-8GbH&q=85&s=5f034a3eb37906cd260bffcb1245353b" width="3600" height="2400" data-path="images/19a21493-message_list_view_default_web_screens-114b0cdcdf4968978684b0c200cf18ab.png" />
</Frame>

**Custom**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/60KLvpM3Vx0byZeU/images/b9c94500-message_list_view_custom_web_screens-ba70aeb87f9a4db083c3a32a1e059a8b.png?fit=max&auto=format&n=60KLvpM3Vx0byZeU&q=85&s=d3bfbd32d1faf726d374bae770cbab66" width="3600" height="2400" data-path="images/b9c94500-message_list_view_custom_web_screens-ba70aeb87f9a4db083c3a32a1e059a8b.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    ThreadedMessagesDemo.tsx

    ```typescript theme={null}
    import React from "react";
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatMessageList,
      CometChatThreadedMessages,
      MessageListAlignment,
      MessageListStyle,
    } from "@cometchat/chat-uikit-react";

    function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] =
        React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>();

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
          setChatWithUser(user);
        });
        CometChat.getMessageDetails("parent Id").then((message) => {
          setParentMessage(message);
        });
      }, []);

      const messageListStyle = new MessageListStyle({
        background: "#fdf2ff",
        border: "1px solid #d608ff",
        borderRadius: "20px",
        loadingIconTint: "red",
        nameTextColor: "pink",
        threadReplyTextColor: "green",
      });
      const CustomListItem = React.useMemo(
        (
          user?: CometChat.User,
          group?: CometChat.Group,
          parentMessage?: CometChat.BaseMessage
        ) => (
          <div style={{ height: "500px" }}>
            <CometChatMessageList
              user={chatUser!}
              messageListStyle={messageListStyle}
              alignment={MessageListAlignment.left}
            />
          </div>
        ),
        []
      );

      return (
        <>
          <CometChatThreadedMessages
            parentMessage={parentMessage}
            messageListView={CustomListItem}
          />
        </>
      );
    }

    export default ThreadedMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    ThreadedMessagesDemo.jsx

    ```javascript theme={null}
    import React, { useState, useEffect, useMemo } from "react";
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatMessageList,
      CometChatThreadedMessages,
      MessageListAlignment,
      MessageListStyle,
    } from "@cometchat/chat-uikit-react";

    function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
    }, []);

      const messageListStyle = useMemo(
        () =>
          new MessageListStyle({
            background: "#fdf2ff",
            border: "1px solid #d608ff",
            borderRadius: "20px",
            loadingIconTint: "red",
            nameTextColor: "pink",
            threadReplyTextColor: "green",
          }),
        []
      );

      const CustomListItem = useMemo(
        () => (
          <div style={{ height: "500px" }}>
            <CometChatMessageList
              user={chatUser}
              messageListStyle={messageListStyle}
              alignment={MessageListAlignment.left}
            />
          </div>
        ),
        [chatUser, messageListStyle]
      );

      return (
        <>
          <CometChatThreadedMessages
            parentMessage={parentMessage}
            messageListView={CustomListItem}
          />
        </>
      );
    }

    export default ThreadedMessagesDemo;
    ```
  </Tab>
</Tabs>

***

#### MessageComposerView

You can set your custom Message Composer view using the `messageComposerView` property. But keep in mind, by using this you will override the default message composer functionality.

**Example**

```javascript theme={null}
messageComposerView={CustomComposerView}
```

**Default**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/D1t_n71f5KROvakA/images/5fcab6b9-composer_view_default_web_screens-cdb99c6277114015af25eed0dc901a67.png?fit=max&auto=format&n=D1t_n71f5KROvakA&q=85&s=102f5bac6cdc5cf0de8a8b3f9070ef0f" width="3600" height="2400" data-path="images/5fcab6b9-composer_view_default_web_screens-cdb99c6277114015af25eed0dc901a67.png" />
</Frame>

**Custom**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d45fac1f-composer_view_custom_web_screens-51e12b0a1bd9c6a0a1ca4d584fddee46.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=e68c5461b9a38ea497dfba70b8702d8d" width="3600" height="2400" data-path="images/d45fac1f-composer_view_custom_web_screens-51e12b0a1bd9c6a0a1ca4d584fddee46.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    ThreadedMessagesDemo.tsx

    ```typescript theme={null}
    import React from "react";
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatMessageComposer,
      CometChatThreadedMessages,
      AuxiliaryButtonAlignment,
      MessageComposerStyle,
    } from "@cometchat/chat-uikit-react";

    function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] =
        React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>();

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
          setChatWithUser(user);
        });
        CometChat.getMessageDetails("parent Id").then((message) => {
          setParentMessage(message);
        });
      }, []);

      const messageComposerStyle = new MessageComposerStyle({
        AIIconTint: "#ec03fc",
        attachIcontint: "#ec03fc",
        background: "#fffcff",
        border: "2px solid #b30fff",
        borderRadius: "20px",
        inputBackground: "#e2d5e8",
        textColor: "#ff299b",
        sendIconTint: "#ff0088",
      });
      const CustomComposerView = React.useMemo(
        (
          user?: CometChat.User,
          group?: CometChat.Group,
          parentMessage?: CometChat.BaseMessage
        ) => (
          <div>
            <CometChatMessageComposer
              messageComposerStyle={messageComposerStyle}
              auxiliaryButtonAlignment={AuxiliaryButtonAlignment.left}
              text="Enter your text here"
            />
          </div>
        ),
        []
      );

      return (
        <>
          <CometChatThreadedMessages
            parentMessage={parentMessage}
            messageComposerView={CustomComposerView}
          />
        </>
      );
    }

    export default ThreadedMessagesDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    ThreadedMessagesDemo.jsx

    ```javascript theme={null}
    import React, { useState, useEffect, useMemo } from "react";
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import {
      CometChatMessageComposer,
      CometChatThreadedMessages,
      AuxiliaryButtonAlignment,
      MessageComposerStyle,
    } from "@cometchat/chat-uikit-react";

    function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
    }, []);

      const messageComposerStyle = useMemo(
        () =>
          new MessageComposerStyle({
            AIIconTint: "#ec03fc",
            attachIcontint: "#ec03fc",
            background: "#fffcff",
            border: "2px solid #b30fff",
            borderRadius: "20px",
            inputBackground: "#e2d5e8",
            textColor: "#ff299b",
            sendIconTint: "#ff0088",
          }),
        []
      );

      const CustomComposerView = useMemo(
        () => (
          <div>
            <CometChatMessageComposer
              messageComposerStyle={messageComposerStyle}
              auxiliaryButtonAlignment={AuxiliaryButtonAlignment.left}
              text="Enter your text here"
            />
          </div>
        ),
        [messageComposerStyle]
      );

      return (
        <>
          {chatUser && (
            <CometChatThreadedMessages
              parentMessage={parentMessage}
              messageComposerView={CustomComposerView}
            />
          )}
        </>
      );
    }

    export default ThreadedMessagesDemo;
    ```
  </Tab>
</Tabs>

***

## Configuration

Configurations offer the ability to customize the properties of each individual component within a Composite Component.

The ThreadedMessages is a Composite Component, and it has a distinct set of configurations for each of its components as follows.

### MessageList

If you want to customize the properties of the [MessageList](/ui-kit/react/v4/message-list) Component inside ThreadedMessages Component, you need use the `MessageListConfiguration` object.

<Tabs>
  <Tab title="ThreadedMessagesDemo.tsx">
    ```typescript theme={null}
    import React from "react";
    import { CometChatThreadedMessages, MessageListConfiguration } from "@cometchat/chat-uikit-react";
    import {CometChat} from "@cometchat/chat-sdk-javascript";

    export function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
      }, []);

      return chatWithUser && parentMessage ? (
        <CometChatThreadedMessages
          parentMessage={parentMessage}
          messageListConfiguration={new MessageListConfiguration({
            //properties of message list
          })}
        />
      ) : null;
    }
    ```
  </Tab>
</Tabs>

The `MessageListConfiguration` provides access to all the [Action](/ui-kit/react/v4/message-list#actions), [Filters](/ui-kit/react/v4/message-list#filters), [Styles](/ui-kit/react/v4/message-list#style), [Functionality](/ui-kit/react/v4/message-list#functionality), and [Advanced](/ui-kit/react/v4/message-list#advance) properties of the [MessageList](/ui-kit/react/v4/message-list) component.

<Info>
  Please note that the properties marked with the [report]() symbol are not accessible within the Configuration Object.
</Info>

**Example**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/y8uIEcRYKgfQIY6z/images/9eacb1fe-threaded_messages_message_list_web_screens-21c166d86a62279143db3726e35b54bd.png?fit=max&auto=format&n=y8uIEcRYKgfQIY6z&q=85&s=90008aebee10656467b71d10811a3cd7" width="3600" height="2400" data-path="images/9eacb1fe-threaded_messages_message_list_web_screens-21c166d86a62279143db3726e35b54bd.png" />
</Frame>

In this example, we will be changing the list alignment and modifying the message list styles in the [MessageList](/ui-kit/react/v4/message-list) component using `MessageListConfiguration`.

<Tabs>
  <Tab title="ThreadedMessagesDemo.tsx">
    ```typescript theme={null}
    import React from "react";
    import { CometChatThreadedMessages, MessageListConfiguration, MessageListStyle, MessageListAlignment } from "@cometchat/chat-uikit-react";
    import {CometChat} from "@cometchat/chat-sdk-javascript";

    export function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
      }, []);
      const messageListStyle = new MessageListStyle({
        background:"transparent",
        border:"1px solid black",
        borderRadius:"20px",
        height:"100%",
        width:"100%",
        loadingIconTint:"red",
        nameTextColor:"pink",
        threadReplyTextColor:"green",
    })
      return chatWithUser && parentMessage ? (
        <CometChatThreadedMessages
          parentMessage={parentMessage}
          messageListConfiguration={new MessageListConfiguration({
            alignment: MessageListAlignment.left,
            messageListStyle:messageListStyle
          })}
        />
      ) : null;
    }
    ```
  </Tab>
</Tabs>

***

### MessageComposer

If you want to customize the properties of the [MessageComposer](/ui-kit/react/v4/message-composer) Component inside ThreadedMessages Component, you need use the `MessageComposerConfiguration` object.

<Tabs>
  <Tab title="ThreadedMessagesDemo.tsx">
    ```typescript theme={null}
    import React from "react";
    import { CometChatThreadedMessages, MessageComposerConfiguration } from "@cometchat/chat-uikit-react";
    import {CometChat} from "@cometchat/chat-sdk-javascript";

    export function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
      }, []);

      return chatWithUser && parentMessage ? (
        <CometChatThreadedMessages
          parentMessage={parentMessage}
          messageComposerConfiguration={new MessageComposerConfiguration({
            //properties of message composer
          })}
        />
      ) : null;
    }
    ```
  </Tab>
</Tabs>

The `MessageComposerConfiguration` provides access to all the [Action](/ui-kit/react/v4/message-composer#actions), [Filters](/ui-kit/react/v4/message-composer#filters), [Styles](/ui-kit/react/v4/message-composer#style), [Functionality](/ui-kit/react/v4/message-composer#functionality), and [Advanced](/ui-kit/react/v4/message-composer#advanced) properties of the [MessageComposer](/ui-kit/react/v4/message-composer) component.

<Info>
  Please note that the properties marked with the [report]() symbol are not accessible within the Configuration Object.
</Info>

**Example**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/y8uIEcRYKgfQIY6z/images/9edebfa3-threaded_messages_message_composer_web_screens-64ebf3e55dd1fce1eabddb370a8c5322.png?fit=max&auto=format&n=y8uIEcRYKgfQIY6z&q=85&s=ddb7774ce12c1d0df8f27dc35fe27ec9" width="3600" height="2400" data-path="images/9edebfa3-threaded_messages_message_composer_web_screens-64ebf3e55dd1fce1eabddb370a8c5322.png" />
</Frame>

In this example, we'll be adding a custom header view and customizing some properties of the [MessageComposer](/ui-kit/react/v4/message-composer) component using `MessageComposerConfiguration`.

<Tabs>
  <Tab title="ThreadedMessagesDemo.tsx">
    ```typescript theme={null}
    import React from "react";
    import { CometChatThreadedMessages, MessageComposerConfiguration, MessageComposerStyle } from "@cometchat/chat-uikit-react";
    import {CometChat} from "@cometchat/chat-sdk-javascript";

    export function ThreadedMessagesDemo() {
      const [parentMessage, setParentMessage] = React.useState<CometChat.BaseMessage>();
      const [chatWithUser, setChatWithUser] = React.useState<CometChat.User>()

      React.useEffect(() => {
        CometChat.getUser("uid").then((user) => {
            setChatWithUser(user);
        })
        CometChat.getMessageDetails("parent Id").then((message)=>{
            setParentMessage(message)
        })
      }, []);
      const messageComposerStyle = new MessageComposerStyle({
      AIIconTint: "#ff006f",
      attachIcontint:"#ec03fc",
      background:"#fffcff",
      border:"2px solid #b30fff",
      borderRadius:"20px",
      inputBackground:"#e2d5e8",
      textColor:"#ff299b",
      sendIconTint:"#ff0088",
      })
      const getHeaderView = () => {
        return (
            <div style={{ height: '40px', width: '100px', background: '#a46efa', borderRadius: '20px', display: 'flex', justifyContent: 'center', alignItems: 'center',  margin:'10px'}}>
                <button style={{ height: '40px', width: '40px', background: '#a46efa', border: 'none', display: 'flex', justifyContent: 'center', alignItems: 'center', cursor:"pointer"  }}>
                    <img src="custom image" style={{ height: 'auto', width: '100%', maxWidth: '100%', maxHeight: '100%', borderRadius: '50%'}} alt="bot" />
                    <span>Chat Bot</span>
                </button>
            </div>
        )
      }

      return chatWithUser && parentMessage ? (
        <CometChatThreadedMessages
          parentMessage={parentMessage}
          messageComposerConfiguration={new MessageComposerConfiguration({
            headerView:getHeaderView()
            messageComposerStyle:messageComposerStyle
          })}
        />
      ) : null;
    }
    ```
  </Tab>
</Tabs>


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Threaded Messages

> Threaded Messages — CometChat documentation.

## Overview

ThreadedMessages is a [Composite Component](/docs/ui-kit/angular/v4/components-overview#composite-components) that displays all replies made to a particular message in a conversation. By default, the parent message will be displayed at the top, the message composer will be at the bottom and between them a message list will contain all replies.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/60KLvpM3Vx0byZeU/images/baa214c1-threaded_messages_overview_web_screens-d7ce5e9d85efcafade9cbf2c60e098e7.png?fit=max&auto=format&n=60KLvpM3Vx0byZeU&q=85&s=580bc9214096db46ffacc4353b107871" width="3600" height="2400" data-path="images/baa214c1-threaded_messages_overview_web_screens-d7ce5e9d85efcafade9cbf2c60e098e7.png" />
</Frame>

ThreadedMessages is composed of the following components:

| Component                                              | Description                                                                                                        |
| ------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------ |
| [MessageList](/docs/ui-kit/angular/v4/message-list)         | CometChatMessageList is a component that displays a list of Messages                                               |
| [MessageComposer](/docs/ui-kit/angular/v4/message-composer) | CometChatMessageComposer is a component that helps in writing and editing of messages and also sending attachments |

## Usage

### Integration

The following code snippet illustrates how you can directly incorporate the ThreadedMessages component into your Application.

<Tabs>
  <Tab title="app.module.ts">
    ```ts theme={null}
    import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from "@angular/core";
    import { BrowserModule } from "@angular/platform-browser";
    import { CometChatThreadedMessages } from "@cometchat/chat-uikit-angular";
    import { AppComponent } from "./app.component";

    @NgModule({
      imports: [BrowserModule, CometChatThreadedMessages],
      declarations: [AppComponent],
      providers: [],
      bootstrap: [AppComponent],
      schemas: [CUSTOM_ELEMENTS_SCHEMA],
    })
    export class AppModule {}
    ```
  </Tab>

  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {
        CometChat.getMessageDetails(parentMessageId).then((message) => {
          if (message instanceof CometChat.TextMessage) {
            this.messageObject = message;
            this.textMessageContent = this.messageObject.getText();
          }
        }).catch((error) => {
          console.error('Error fetching message details:', error);
          this.textMessageContent = '';
        });
      }

      public messageObject!: CometChat.TextMessage;
      public textMessageContent: string | undefined;

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding:"5px",
        border:"1px solid #e9b8f5",
        titleColor:"#8830f2",
        borderRadius:"20px",
        width:"100% !important"
      });

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <cometchat-threaded-messages
    *ngIf="messageObject"
    [parentMessage]="messageObject"
    [bubbleView]="bubbleViewTemplate"
    ></cometchat-threaded-messages>
    </div>

    <ng-template #bubbleViewTemplate>
      <div>
        <cometchat-list-item
        [title]="textMessageContent"
        [listItemStyle]="listItemStyle"
        ></cometchat-list-item>
        </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/docs/ui-kit/angular/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

**Example**

In this example, we are overriding the `onClose` of the ThreadedMessage Component.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {
        CometChat.getMessageDetails(parentMessageId).then((message) => {
          if (message instanceof CometChat.TextMessage) {
            this.messageObject = message;
            this.textMessageContent = this.messageObject.getText();
          }
        }).catch((error) => {
          console.error('Error fetching message details:', error);
          this.textMessageContent = '';
        });
      }

      public messageObject!: CometChat.TextMessage;
      public textMessageContent: string | undefined;
      public handleOnClose = () => {
        console.log("Your custom on close actions");
      }
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding:"5px",
        border:"1px solid #e9b8f5",
        titleColor:"#8830f2",
        borderRadius:"20px",
        width:"100% !important"
      });

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <cometchat-threaded-messages
    *ngIf="messageObject"
    [parentMessage]="messageObject"
    [bubbleView]="bubbleViewTemplate"
    [onClose]="handleOnClose"
    ></cometchat-threaded-messages>
    </div>

    <ng-template #bubbleViewTemplate>
      <div>
        <cometchat-list-item
        [title]="textMessageContent"
        [listItemStyle]="listItemStyle"
        ></cometchat-list-item>
        </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

### Filters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

ThreadedMessages does not have its own Filters. However, you can filter the messages list in ThreadedMessages Component using [MessageListConfiguration](#messagelist).

**Example**

In this example, we are filtering messages based on the ParentMessageID and searching for messages that contain the keyword "hi".

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import { MessageListConfiguration }  from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {
        CometChat.getMessageDetails(parentMessageId).then((message) => {
          if (message instanceof CometChat.TextMessage) {
            this.messageObject = message;
            this.textMessageContent = this.messageObject.getText();
          }
        }).catch((error) => {
          console.error('Error fetching message details:', error);
          this.textMessageContent = '';
        });
      }

      public messageObject!: CometChat.TextMessage;
      public textMessageContent: string | undefined;
      public messageListConfiguration = new MessageListConfiguration({
        messagesRequestBuilder: new CometChat.MessagesRequestBuilder().setParentMessageId(id).setSearchKeyword("hi").setLimit(1),
      });
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding:"5px",
        border:"1px solid #e9b8f5",
        titleColor:"#8830f2",
        borderRadius:"20px",
        width:"100% !important"
      });

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <cometchat-threaded-messages
    *ngIf="messageObject"
    [parentMessage]="messageObject"
    [bubbleView]="bubbleViewTemplate"
    [messageListConfiguration]="messageListConfiguration"
    ></cometchat-threaded-messages>
    </div>

    <ng-template #bubbleViewTemplate>
      <div>
        <cometchat-list-item
        [title]="textMessageContent"
        [listItemStyle]="listItemStyle"
        ></cometchat-list-item>
        </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/docs/ui-kit/angular/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

The ThreadedMessages Component does not emit any events of its own.

***

## Customization

To fit your app's design requirements, you can customize the appearance of the conversation component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

***

### Style

Using Style you can customize the look and feel of the component in your app, These parameters typically control elements such as the color, size, shape, and fonts used within the component.

##### 1. threadedMessagesStyle

To modify the styling, you can apply the ThreadedMessageStyle to the ThreadedMessage Component using the `threadedMessagesStyle` property.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import { ThreadedMessagesStyle }  from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {
        CometChat.getMessageDetails(parentMessageId).then((message) => {
          if (message instanceof CometChat.TextMessage) {
            this.messageObject = message;
            this.textMessageContent = this.messageObject.getText();
          }
        }).catch((error) => {
          console.error('Error fetching message details:', error);
          this.textMessageContent = '';
        });
      }

      public messageObject!: CometChat.TextMessage;
      public textMessageContent: string | undefined;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding:"5px",
        border:"1px solid #e9b8f5",
        titleColor:"#8830f2",
        borderRadius:"20px",
        width:"100% !important"
      });
      threadedMessagesStyle = new ThreadedMessagesStyle({
        background: "#ebdeff",
        width: "100%",
        height: "600px",
        border: "2px solid #9e19e0"
      });

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <cometchat-threaded-messages
    *ngIf="messageObject"
    [parentMessage]="messageObject"
    [bubbleView]="bubbleViewTemplate"
    [threadedMessagesStyle]="threadedMessagesStyle"
    ></cometchat-threaded-messages>
    </div>

    <ng-template #bubbleViewTemplate>
      <div>
        <cometchat-list-item
        [title]="textMessageContent"
        [listItemStyle]="listItemStyle"
        ></cometchat-list-item>
        </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

The following properties are exposed by `ThreadedMessagesStyle`:

| Methods           | Description                                             | Type                      |
| ----------------- | ------------------------------------------------------- | ------------------------- |
| **border**        | Used to set border                                      | `border?: string,`        |
| **borderRadius**  | Used to set border radius                               | `borderRadius?: string;`  |
| **background**    | Used to set background colour                           | `background?: string;`    |
| **height**        | Used to set height                                      | `height?: string;`        |
| **width**         | Used to set width                                       | `width?: string;`         |
| **titleFont**     | used to customise the font of the title in the app bar  | `titleFont?: string;`     |
| **titleColor**    | used to customise the color of the title in the app bar | `titleColor?: string;`    |
| **closeIconTint** | used to set the color of the close icon in the app bar  | `closeIconTint?: string;` |

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {
        CometChat.getMessageDetails(parentMessageId).then((message) => {
          if (message instanceof CometChat.TextMessage) {
            this.messageObject = message;
            this.textMessageContent = this.messageObject.getText();
          }
        }).catch((error) => {
          console.error('Error fetching message details:', error);
          this.textMessageContent = '';
        });
      }

      public messageObject!: CometChat.TextMessage;
      public textMessageContent: string | undefined;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding:"5px",
        border:"1px solid #e9b8f5",
        titleColor:"#8830f2",
        borderRadius:"20px",
        width:"100% !important"
      });
      title = 'Your Custom Title';
      public myCustomIcon = 'your custom icon';

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <cometchat-threaded-messages
    *ngIf="messageObject"
    [parentMessage]="messageObject"
    [bubbleView]="bubbleViewTemplate"
    [title]="title"
    [closeIconURL]="myCustomIcon"
    ></cometchat-threaded-messages>
    </div>

    <ng-template #bubbleViewTemplate>
      <div>
        <cometchat-list-item
        [title]="textMessageContent"
        [listItemStyle]="listItemStyle"
        ></cometchat-list-item>
        </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

Below is a list of customizations along with corresponding code snippets

| Property                                                    | Description                                                           | Code                                        |
| ----------------------------------------------------------- | --------------------------------------------------------------------- | ------------------------------------------- |
| **parentMessage** <Tooltip tip="Not available">🛑</Tooltip> | Used to to set the message for which the replies need to be fetched   | `[parentMessage]="messageObject"`           |
| **Hide MessageComposer**                                    | Used to toggle visibility for CometChatMessageComposer, default false | `[hideMessageComposer]="true"`              |
| **title**                                                   | Used to set title in the app bar                                      | `[title]="title"`                           |
| **closeIconURL**                                            | Used to set the icon to exit the widget                               | `closeIconURL="your custom close icon url"` |

***

### Advanced

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

#### BubbleView

By using `bubbleView`, You can set parent message bubble view inside ThreadedMessage Component.

**Example**

**Default**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/aledzZZMtw_sXx4U/images/f9fbbc9c-threaded_messages_bubbleview_default_web_screens-b84cc7fe214fa4e70518ff431d89008c.png?fit=max&auto=format&n=aledzZZMtw_sXx4U&q=85&s=133aeaff2ce2e663a58d778aa89a9ab4" width="3600" height="2400" data-path="images/f9fbbc9c-threaded_messages_bubbleview_default_web_screens-b84cc7fe214fa4e70518ff431d89008c.png" />
</Frame>

**Custom**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/v4EbHQCGZ54oJcmr/images/57cae1e6-threaded_messages_bubbleview_custom_web_screens-8ae16601fe81efe66ef9890a5542c2a2.png?fit=max&auto=format&n=v4EbHQCGZ54oJcmr&q=85&s=b00921dbf1dfa1f2966644f345967538" width="3600" height="2400" data-path="images/57cae1e6-threaded_messages_bubbleview_custom_web_screens-8ae16601fe81efe66ef9890a5542c2a2.png" />
</Frame>

In this example, we will set parent message bubble view using `bubbleView` and apply custom styles on it.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {
        CometChat.getMessageDetails(parentMessageId).then((message) => {
          if (message instanceof CometChat.TextMessage) {
            this.messageObject = message;
            this.textMessageContent = this.messageObject.getText();
          }
        }).catch((error) => {
          console.error('Error fetching message details:', error);
          this.textMessageContent = '';
        });
      }

      public messageObject!: CometChat.TextMessage;
      public textMessageContent: string | undefined;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding:"5px",
        border:"1px solid #e9b8f5",
        titleColor:"#8830f2",
        borderRadius:"20px",
        width:"100% !important"
      });

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <cometchat-threaded-messages
    *ngIf="messageObject"
    [parentMessage]="messageObject"
    [bubbleView]="bubbleViewTemplate"
    ></cometchat-threaded-messages>
    </div>

    <ng-template #bubbleViewTemplate>
      <div>
        <cometchat-list-item
        [title]="textMessageContent"
        [listItemStyle]="listItemStyle"
        ></cometchat-list-item>
        </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

#### MessageActionView

By utilizing the `messageActionView` method, you can assign custom actions to the parent message bubble view inside the ThreadedMessage Component.

**Example**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/8YlylzCf9CehSaWO/images/cbe3d276-threaded_messages_actionview_web_screens-af8001a225e368848ca95bf650161733.png?fit=max&auto=format&n=8YlylzCf9CehSaWO&q=85&s=7b0f520131e5c909352eda93b02d252f" width="3600" height="2400" data-path="images/cbe3d276-threaded_messages_actionview_web_screens-af8001a225e368848ca95bf650161733.png" />
</Frame>

In this example, we are setting mock Chat Bot button as message action view in ThreadedMessages Component.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {
        CometChat.getMessageDetails(parentMessageId).then((message) => {
          if (message instanceof CometChat.TextMessage) {
            this.messageObject = message;
            this.textMessageContent = this.messageObject.getText();
          }
        }).catch((error) => {
          console.error('Error fetching message details:', error);
          this.textMessageContent = '';
        });
      }

      public messageObject!: CometChat.TextMessage;
      public textMessageContent: string | undefined;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding:"5px",
        border:"1px solid #e9b8f5",
        titleColor:"#8830f2",
        borderRadius:"20px",
        width:"100% !important"
      });
      public myCustomIcon="your custom icon";

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <cometchat-threaded-messages
    *ngIf="messageObject"
    [parentMessage]="messageObject"
    [bubbleView]="bubbleViewTemplate"
    [messageActionView]="messageActionViewTemplate"
    ></cometchat-threaded-messages>
    </div>

    <ng-template #bubbleViewTemplate>
      <div>
        <cometchat-list-item
        [title]="textMessageContent"
        [listItemStyle]="listItemStyle"
        ></cometchat-list-item>
        </div>
    </ng-template>

    <ng-template #messageActionViewTemplate>
      <div
        [ngStyle]="{ height: '40px', width: '100px', background: '#a46efa', borderRadius: '20px', display: 'flex', justifyContent: 'center', alignItems: 'center', margin: '10px' }">
        <button
          [ngStyle]="{ height: '40px', width: '40px', background: '#a46efa', border: 'none', display: 'flex', justifyContent: 'center', alignItems: 'center', cursor: 'pointer' }">
          <img [src]="myCustomIcon"
            [ngStyle]="{ height: 'auto', width: '100%', maxWidth: '100%', maxHeight: '100%', borderRadius: '50%' }"
            alt="bot" />
          <span>Chat Bot</span>
        </button>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### MessageListView

You can set your custom message list view using the `messageListView` property. But keep in mind, by using this you will override the default message ListView functionality.

**Example**

**Default**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/RxKy5RgybeX-8GbH/images/19a21493-message_list_view_default_web_screens-114b0cdcdf4968978684b0c200cf18ab.png?fit=max&auto=format&n=RxKy5RgybeX-8GbH&q=85&s=5f034a3eb37906cd260bffcb1245353b" width="3600" height="2400" data-path="images/19a21493-message_list_view_default_web_screens-114b0cdcdf4968978684b0c200cf18ab.png" />
</Frame>

**Custom**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/60KLvpM3Vx0byZeU/images/b9c94500-message_list_view_custom_web_screens-ba70aeb87f9a4db083c3a32a1e059a8b.png?fit=max&auto=format&n=60KLvpM3Vx0byZeU&q=85&s=d3bfbd32d1faf726d374bae770cbab66" width="3600" height="2400" data-path="images/b9c94500-message_list_view_custom_web_screens-ba70aeb87f9a4db083c3a32a1e059a8b.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import { MessageListStyle } from '@cometchat/uikit-shared';
    import { MessageListAlignment } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {

        CometChat.getUser("uid").then((user: CometChat.User) => {
          this.userObject = user;
        });

        CometChat.getMessageDetails(parentMessageId).then((message) => {
          if (message instanceof CometChat.TextMessage) {
            this.messageObject = message;
            this.textMessageContent = this.messageObject.getText();
          }
        }).catch((error) => {
          console.error('Error fetching message details:', error);
          this.textMessageContent = '';
        });
      }

      public messageObject!: CometChat.TextMessage;
      public textMessageContent: string | undefined;
      public userObject!: CometChat.User;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding:"5px",
        border:"1px solid #e9b8f5",
        titleColor:"#8830f2",
        borderRadius:"20px",
        width:"100% !important"
      });
      messageListStyle = new MessageListStyle({
        background: "#fdf2ff",
        border: "1px solid #d608ff",
        borderRadius: "20px",
        loadingIconTint: "red",
        nameTextColor: "pink",
        threadReplyTextColor: "green"
      });
      alignment = MessageListAlignment.left;

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <cometchat-threaded-messages
    *ngIf="messageObject"
    [parentMessage]="messageObject"
    [bubbleView]="bubbleViewTemplate"
    [messageListView]="messageListViewTemplate"
    ></cometchat-threaded-messages>
    </div>

    <ng-template #bubbleViewTemplate>
      <div>
        <cometchat-list-item
        [title]="textMessageContent"
        [listItemStyle]="listItemStyle"
        ></cometchat-list-item>
        </div>
    </ng-template>

    <ng-template #messageListViewTemplate>
      <div>
        <cometchat-message-list [user]="userObject" [messageListStyle]="messageListStyle"
          [alignment]="alignment"></cometchat-message-list>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### MessageComposerView

You can set your custom Message Composer view using the `messageComposerView` property. But keep in mind, by using this you will override the default message composer functionality.

**Example**

**Default**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/D1t_n71f5KROvakA/images/5fcab6b9-composer_view_default_web_screens-cdb99c6277114015af25eed0dc901a67.png?fit=max&auto=format&n=D1t_n71f5KROvakA&q=85&s=102f5bac6cdc5cf0de8a8b3f9070ef0f" width="3600" height="2400" data-path="images/5fcab6b9-composer_view_default_web_screens-cdb99c6277114015af25eed0dc901a67.png" />
</Frame>

**Custom**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/4xujL4pc0yDqaECl/images/d45fac1f-composer_view_custom_web_screens-51e12b0a1bd9c6a0a1ca4d584fddee46.png?fit=max&auto=format&n=4xujL4pc0yDqaECl&q=85&s=e68c5461b9a38ea497dfba70b8702d8d" width="3600" height="2400" data-path="images/d45fac1f-composer_view_custom_web_screens-51e12b0a1bd9c6a0a1ca4d584fddee46.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import { MessageComposerStyle } from '@cometchat/uikit-shared';
    import { AuxiliaryButtonAlignment } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {

        CometChat.getUser("uid").then((user: CometChat.User) => {
          this.userObject = user;
        });

        CometChat.getMessageDetails(parentMessageId).then((message) => {
          if (message instanceof CometChat.TextMessage) {
            this.messageObject = message;
            this.textMessageContent = this.messageObject.getText();
          }
        }).catch((error) => {
          console.error('Error fetching message details:', error);
          this.textMessageContent = '';
        });
      }

      public messageObject!: CometChat.TextMessage;
      public textMessageContent: string | undefined;
      public userObject!: CometChat.User;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding:"5px",
        border:"1px solid #e9b8f5",
        titleColor:"#8830f2",
        borderRadius:"20px",
        width:"100% !important"
      });
      messageComposerStyle = new MessageComposerStyle({
        AIIconTint:"#ec03fc",
        attachIcontint:"#ec03fc",
        background:"#fffcff",
        border:"2px solid #b30fff",
        borderRadius:"20px",
        inputBackground:"#e2d5e8",
        textColor:"#ff299b",
        sendIconTint:"#ff0088",
      });
      auxiliaryButtonAlignment = AuxiliaryButtonAlignment.left;

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <cometchat-threaded-messages
    *ngIf="messageObject"
    [parentMessage]="messageObject"
    [bubbleView]="bubbleViewTemplate"
    [messageComposerView]="messageComposerViewTemplate"
    ></cometchat-threaded-messages>
    </div>

    <ng-template #bubbleViewTemplate>
      <div>
        <cometchat-list-item
        [title]="textMessageContent"
        [listItemStyle]="listItemStyle"
        ></cometchat-list-item>
        </div>
    </ng-template>

    <ng-template #messageComposerViewTemplate>
      <div>
        <cometchat-message-composer [user]="userObject" [messageComposerStyle]="messageComposerStyle"
          [auxiliaryButtonAlignment]="auxiliaryButtonAlignment"></cometchat-message-composer>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

## Configuration

Configurations offer the ability to customize the properties of each individual component within a Composite Component.

The ThreadedMessages is a Composite Component, and it has a distinct set of configurations for each of its components as follows.

### MessageList

If you want to customize the properties of the [MessageList](/docs/ui-kit/angular/v4/message-list) Component inside ThreadedMessages Component, you need use the `MessageListConfiguration` object.

The `MessageListConfiguration` provides access to all the [Action](/docs/ui-kit/angular/v4/message-list#actions), [Filters](/docs/ui-kit/angular/v4/message-list#filters), [Styles](/docs/ui-kit/angular/v4/message-list#style), [Functionality](/docs/ui-kit/angular/v4/message-list#functionality), and [Advanced](/docs/ui-kit/angular/v4/message-list#advance) properties of the [MessageList](/docs/ui-kit/angular/v4/message-list) component.

> Please note that the Properties marked with the 🛑 symbol are not accessible within the Configuration Object.

**Example**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/y8uIEcRYKgfQIY6z/images/9eacb1fe-threaded_messages_message_list_web_screens-21c166d86a62279143db3726e35b54bd.png?fit=max&auto=format&n=y8uIEcRYKgfQIY6z&q=85&s=90008aebee10656467b71d10811a3cd7" width="3600" height="2400" data-path="images/9eacb1fe-threaded_messages_message_list_web_screens-21c166d86a62279143db3726e35b54bd.png" />
</Frame>

In this example, we will be changing the list alignment and modifying the message list styles in the [MessageList](/docs/ui-kit/angular/v4/message-list) component using `MessageListConfiguration`.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import { MessageListConfiguration, MessageListStyle } from '@cometchat/uikit-shared';
    import { MessageListAlignment } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {

        CometChat.getUser("uid").then((user: CometChat.User) => {
          this.userObject = user;
        });

        CometChat.getMessageDetails(parentMessageId).then((message) => {
          if (message instanceof CometChat.TextMessage) {
            this.messageObject = message;
            this.textMessageContent = this.messageObject.getText();
          }
        }).catch((error) => {
          console.error('Error fetching message details:', error);
          this.textMessageContent = '';
        });
      }

      public messageObject!: CometChat.TextMessage;
      public textMessageContent: string | undefined;
      public userObject!: CometChat.User;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding:"5px",
        border:"1px solid #e9b8f5",
        titleColor:"#8830f2",
        borderRadius:"20px",
        width:"100% !important"
      });
     public messageListConfiguration = new MessageListConfiguration({
        messageListStyle: new MessageListStyle({
          background:"#d8cae6",
            border:"2px solid #6107ba",
            borderRadius:"20px",
            loadingIconTint:"red",
            nameTextColor:"pink",
            threadReplyTextColor:"green"
        }),
        alignment: MessageListAlignment.left,
      });

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <cometchat-threaded-messages
    *ngIf="messageObject"
    [parentMessage]="messageObject"
    [bubbleView]="bubbleViewTemplate"
    [messageListConfiguration]="messageListConfiguration"
    ></cometchat-threaded-messages>
    </div>

    <ng-template #bubbleViewTemplate>
      <div>
        <cometchat-list-item
        [title]="textMessageContent"
        [listItemStyle]="listItemStyle"
        ></cometchat-list-item>
        </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

### MessageComposer

If you want to customize the properties of the [MessageComposer](/docs/ui-kit/angular/v4/message-composer) Component inside ThreadedMessages Component, you need use the `MessageComposerConfiguration` object.

The `MessageComposerConfiguration` provides access to all the [Action](/docs/ui-kit/angular/v4/message-composer#actions), [Filters](/docs/ui-kit/angular/v4/message-composer#filters), [Styles](/docs/ui-kit/angular/v4/message-composer#style), [Functionality](/docs/ui-kit/angular/v4/message-composer#functionality), and [Advanced](/docs/ui-kit/angular/v4/message-composer#advanced) properties of the [MessageComposer](/docs/ui-kit/angular/v4/message-composer) component.

> Please note that the Properties marked with the 🛑 symbol are not accessible within the Configuration Object.

**Example**

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/y8uIEcRYKgfQIY6z/images/9edebfa3-threaded_messages_message_composer_web_screens-64ebf3e55dd1fce1eabddb370a8c5322.png?fit=max&auto=format&n=y8uIEcRYKgfQIY6z&q=85&s=ddb7774ce12c1d0df8f27dc35fe27ec9" width="3600" height="2400" data-path="images/9edebfa3-threaded_messages_message_composer_web_screens-64ebf3e55dd1fce1eabddb370a8c5322.png" />
</Frame>

In this example, we'll be adding a custom header view and customizing some properties of the [MessageComposer](/docs/ui-kit/angular/v4/message-composer) component using `MessageComposerConfiguration`.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import { MessageComposerConfiguration, MessageComposerStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent implements OnInit{
      ngOnInit(): void {

        CometChat.getUser("uid").then((user: CometChat.User) => {
          this.userObject = user;
        });

        CometChat.getMessageDetails(parentMessageId).then((message) => {
          if (message instanceof CometChat.TextMessage) {
            this.messageObject = message;
            this.textMessageContent = this.messageObject.getText();
          }
        }).catch((error) => {
          console.error('Error fetching message details:', error);
          this.textMessageContent = '';
        });
        this.messageComposerConfiguration =  new MessageComposerConfiguration({
          // property of message composer configuration
          headerView:this.headerView,
          messageComposerStyle: new MessageComposerStyle({
            AIIconTint: "#ec03fc",
            attachIcontint: "#ec03fc",
            background: "#fffcff",
            border: "2px solid #b30fff",
            borderRadius: "20px",
            inputBackground: "#e2d5e8",
            textColor: "#ff299b",
            sendIconTint: "#ff0088",
          })
        });
      }

      public messageObject!: CometChat.TextMessage;
      public textMessageContent: string | undefined;
      public userObject!: CometChat.User;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding:"5px",
        border:"1px solid #e9b8f5",
        titleColor:"#8830f2",
        borderRadius:"20px",
        width:"100% !important"
      });
      public messageComposerConfiguration !: MessageComposerConfiguration;

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <cometchat-threaded-messages
    *ngIf="messageObject"
    [parentMessage]="messageObject"
    [bubbleView]="bubbleViewTemplate"
    [messageComposerConfiguration]="messageComposerConfiguration"
    ></cometchat-threaded-messages>
    </div>

    <ng-template #bubbleViewTemplate>
      <div>
        <cometchat-list-item
        [title]="textMessageContent"
        [listItemStyle]="listItemStyle"
        ></cometchat-list-item>
        </div>
    </ng-template>
    <ng-template #headerView>
      <div
        [ngStyle]="{ height: '40px', width: '100px', background: '#a46efa', borderRadius: '20px', display: 'flex', justifyContent: 'center', alignItems: 'center', margin: '10px' }">
        <button
          [ngStyle]="{ height: '40px', width: '40px', background: '#a46efa', border: 'none', display: 'flex', justifyContent: 'center', alignItems: 'center', cursor: 'pointer' }">
          <img [src]="myCustomIcon"
            [ngStyle]="{ height: 'auto', width: '100%', maxWidth: '100%', maxHeight: '100%', borderRadius: '50%' }"
            alt="bot" />
          <span>Chat Bot</span>
        </button>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>
